<template>
    <div
        class="w-full"
    >
        <header-circle-container>
            <div
                class="capitalize font-black text-xl mb-14"
            >
                {{ $t('ranking_' + $user.ranking) }}
            </div>
        </header-circle-container>
        <div
            class="px-3 -mt-12 w-full lg:max-w-[400px] lg:text-center lg:mx-auto"
        >
            <div
                class="grid grid-cols-3 gap-3 shadow-lg rounded-xl bg-white shadow-lg shadow-gray-300 text-center"
            >
                <div
                    class="text-center flex flex-col justify-center items-center py-4 cursor-pointer"
                    @click="invitePrompt = true"
                >
                    <user-plus-icon
                        class="w-8"
                    />
                    <div
                        class="uppercase font-bold"
                    >
                        {{ $t('invite') }}
                    </div>
                </div>
                <div
                    class="text-center flex flex-col justify-center items-center py-4 cursor-pointer"
                    @click="$router.push({name: 'user.team.calculator.home'})"
                >
                    <calculator-icon
                        class="w-8"
                    />
                    <div
                        class="uppercase font-bold"
                    >
                        {{ $t('calculator') }}
                    </div>
                </div>
                <div
                    class="text-center flex flex-col justify-center items-center py-4 cursor-pointer"
                    @click="$router.push({name: 'user.team.hierarchy.home'})"
                >
                    <user-group-icon
                        class="w-8"
                    />
                    <div
                        class="uppercase font-bold"
                    >
                        {{ $t('hierarchy') }}
                    </div>
                </div>
            </div>
        </div>
        <div
            class="px-3 w-full lg:max-w-[400px] lg:text-center lg:mx-auto grid grid-cols-2 gap-2 mt-4"
        >
            <custom-card>
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/direct-team-size.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-xs font-bold mb-1 leading-tight capitalize"
                        >
                            {{ $t('direct_team_size')}}
                        </div>
                        <div
                            class="font-black"
                        >
                            {{ $helper.fundFormat(teamData.direct_team_size || 0, 0) }}
                        </div>
                    </div>
                </div>
            </custom-card>
            <custom-card>
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/direct-team-portfolio.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-xs font-bold mb-1 leading-tight capitalize"
                        >
                            {{ $t('direct_team_portfolio')}}
                        </div>
                        <div
                            class="font-black"
                        >
                            <span>$ </span>{{ $helper.fundFormat(teamData.direct_team_portfolio || 0, 0) }}
                        </div>
                    </div>
                </div>
            </custom-card>
            <custom-card>
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/team-size.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-xs font-bold mb-1 leading-tight capitalize"
                        >
                            {{ $t('team_size')}}
                        </div>
                        <div
                            class="font-black"
                        >
                            {{ $helper.fundFormat(teamData.team_size || 0, 0)}}
                        </div>
                    </div>
                </div>
            </custom-card>
            <custom-card>
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/team-portfolio.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-xs font-bold mb-1 leading-tight capitalize"
                        >
                            {{ $t('team_portfolio')}}
                        </div>
                        <div
                            class="font-black"
                        >
                            <span>$ </span> {{ $helper.fundFormat(teamData.team_portfolio || 0, 0)}}
                        </div>
                    </div>
                </div>
            </custom-card>
            <div
                class="col-span-2"
            >
                <custom-card>
                    <div
                        class="flex justify-start space-x-3"
                    >
                        <div>
                            <img
                                :src="'/img/bmb-team-size.png'"
                                class="w-8"
                            />
                        </div>
                        <div
                            class="flex flex-col justify-start items-start"
                        >
                            <div
                                class="text-xsfont-bold mb-1 leading-tight capitalize"
                            >
                                {{ $t('bmb_team_size')}}
                            </div>
                            <div
                                class="font-black"
                            >
                                {{ $helper.fundFormat($user.bmb_count, 0) }}
                            </div>
                        </div>
                    </div>
                </custom-card>
            </div>
<!--            <custom-card>-->
<!--                <div-->
<!--                    class="flex justify-start space-x-3"-->
<!--                >-->
<!--                    <div>-->
<!--                        <img-->
<!--                            :src="'/img/bmi-team-size.png'"-->
<!--                            class="w-8"-->
<!--                        />-->
<!--                    </div>-->
<!--                    <div-->
<!--                        class="flex flex-col justify-start items-start"-->
<!--                    >-->
<!--                        <div-->
<!--                            class="text-xs font-bold mb-1 leading-tight capitalize"-->
<!--                        >-->
<!--                            {{ $t('bmi_team_size')}}-->
<!--                        </div>-->
<!--                        <div-->
<!--                            class="font-black"-->
<!--                        >-->
<!--                            {{ $helper.fundFormat($user.bmi_count, 0) }}-->
<!--                        </div>-->
<!--                    </div>-->
<!--                </div>-->
<!--            </custom-card>-->
        </div>
        <div
            class="px-3 my-4 w-full lg:max-w-[400px] lg:mx-auto"
        >
            <div class="pl-2 font-black uppercase">{{ $t('my_direct_referred') }}</div>
            <template
                v-if="teamData['direct_team'] && teamData['direct_team'].length"
            >
                <div
                    class="flex flex-col justify-start space-y-2 mt-3"
                >
                    <div
                        v-for="(dt, key) in teamData['direct_team']"
                        :key="dt.member_id"
                        class="w-full shadow-lg rounded-xl bg-white text-black shadow-gray-300 relative p-3"
                    >
                        <div
                            class="capitalize font-black"
                        >
                            {{ $t('line') }} {{ teamData['direct_team'].length - key }}: {{ dt.username }}
                        </div>
                        <div
                            class="text-xs"
                        >
                            {{ $t('ranking_' + dt.ranking) }}
                        </div>
                        <div
                            class="capitalize font-black"
                        >
                            {{ $t('group_sales') }}: {{ $helper.fundFormat(dt.group_sales) }}
                        </div>
                        <div
                            class="mt-4 grid grid-cols-3 gap-3 font-black"
                        >
                            <div>{{ $t('bm1') }}: {{ dt.downline_ranking_1 }}</div>
                            <div>{{ $t('bm2') }}: {{ dt.downline_ranking_2 }}</div>
                            <div>{{ $t('bm3') }}: {{ dt.downline_ranking_3 }}</div>
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 capitalize"
                        >
                            <div
                                v-if="parseFloat(dt.total_investments) > 0"
                                class="text-green-500 font-black"
                            >
                                {{ $t('active') }}
                            </div>
                            <div
                                v-else

                                class="text-red-500 font-black"
                            >
                                {{ $t('inactive') }}
                            </div>
                        </div>
                    </div>
                </div>
            </template>
            <div
                v-else
                class="px-3 text-xs text-center py-4"
            >
                {{ $t('you_have_no_direct_referred_investors') }}
            </div>
        </div>
        <confirmation-prompt
            v-if="invitePrompt"
            @close="invitePrompt = false"
        >
            <div
                class="font-black capitalize text-lg text-center"
            >
                {{ $t('invite_new_investor') }}
            </div>
            <div
                class="my-3"
            >
                {{ $t('share_or_invite_investor_earn_bonus_incentives') }}
            </div>
            <div
                class="flex flex-col justify-start space-y-4 mt-4"
            >
                <div class="w-full">
                    <div
                        class="bg-purple-600 text-white font-bold text-center uppercase cursor-pointer w-full px-4 py-3 rounded-sm"
                        @click="copyInviteLink"
                    >
                        {{ $t('copy_referral_link') }}
                    </div>
                </div>
                <div class="w-full">
                    <div
                        class="bg-green-600 text-white font-bold text-center uppercase cursor-pointer w-full px-4 py-3 rounded-sm"
                        @click="shareInviteLink"
                    >
                        {{ $t('share') }}
                    </div>
                </div>
            </div>
        </confirmation-prompt>
    </div>
</template>

<script setup>
import CustomCard from "~/components/custom-card.vue";
import HeaderCircleContainer from "~/components/header-circle-container.vue";
import {UserPlusIcon, CalculatorIcon, UserGroupIcon} from "@heroicons/vue/24/outline";
import {ref, computed, inject, onMounted} from "vue";
import ConfirmationPrompt from "~/components/confirmation-prompt.vue";
import {useRouter} from "vue-router";
import {useUserStore} from "~/stores/user.js";
import {useI18n} from "vue-i18n";
import axios from "axios";

const $helper = inject('$helper');
const i18n = useI18n();
const $router = useRouter();
const $userStore = useUserStore();
const $user = computed(() => {
    return $userStore.account;
});

const invitePrompt = ref(false);
const inviteLink = computed(() => {
    return new URL($router.resolve({name: 'user.auth.register', query: {r: $user.value.member_id}}).href, window.location.origin).href;
});

const teamData = ref({});

const copyInviteLink = async () => {
    await $helper.copyText(inviteLink.value, async () => {
        await $helper.alertSuccess({
            message: i18n.t('successfully_copied'),
            callback: () => {
                invitePrompt.value = false;
            }
        })
    });
};
const shareInviteLink = async () => {
    try {
        if (navigator && navigator.share) {
            navigator.share({
                title: i18n.t('invite_new_investor'),
                url: inviteLink.value,
            });
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    const data = await axios.post('/team/fetch_data');

    teamData.value = {...data};
});
</script>
